"""
Django settings for api project.

Generated by 'django-admin startproject' using Django 3.0.8.

For more information on this file, see
https://docs.djangoproject.com/en/3.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.0/ref/settings/
"""

import os
# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
from datetime import timedelta
from enum import Enum

from celery.schedules import crontab

BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'n47ny7qobe_qt8b4yq08i%&fsa8y!+^mj)z00g#px1_xa&^oa1'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

APPEND_SLASH = False

LOGIN_REDIRECT_URL = '/index'

# Application definition

ALLOWED_HOSTS = ['*']

INSTALLED_APPS = [
    'menu.apps.MenuConfig',
    'order.apps.OrderConfig',
    'store.apps.StoreConfig',
    'administration.apps.AdministrationConfig',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'drf_yasg',
    'rest_framework_xml',
    'rest_framework.authtoken',
    'django_celery_beat',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'api.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': ['templeates'],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'api.wsgi.application'

# Database
# https://docs.djangoproject.com/en/3.0/ref/settings/#databases

# DATABASES = {
#     'default': {
#         'ENGINE': 'django.db.backends.sqlite3',
#         'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),
#     }
# }

# DATABASES = {
#     'default': {
#         'ENGINE': 'django.db.backends.postgresql_psycopg2',
#         'NAME': 'drf_api_db',
#         'USER': 'eddy',
#         'PASSWORD': 'Eddy/*910918.',
#         'HOST': 'localhost',
#         'PORT': '5432',
#     }
# }

# DATABASES = {
#     'default': {
#         'ENGINE': 'django.db.backends.postgresql_psycopg2',
#         'NAME': 'drf_api_db',
#         'USER': 'eddy',
#         'PASSWORD': 'Eddy/*910918.',
#         'HOST': 'localhost',
#         'PORT': '5432',
#     }
# }

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': 'drf_api_db2',
        'USER': 'postgres',
        'PASSWORD': 'Eddy/*910918.',
        'HOST': 'localhost',
        'PORT': '5432',
    }
}

# Password validation
# https://docs.djangoproject.com/en/3.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Internationalization
# https://docs.djangoproject.com/en/3.0/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.0/howto/static-files/

STATIC_URL = '/static/'

REST_FRAMEWORK = {
    'DEFAULT_PARSER_CLASSES': (
        'rest_framework.parsers.JSONParser',
    ),
    'DEFAULT_RENDERER_CLASSES': (
        'rest_framework.renderers.JSONRenderer',
        'rest_framework_xml.renderers.XMLRenderer',
        'rest_framework_datatables.renderers.DatatablesRenderer',
        'rest_framework.renderers.BrowsableAPIRenderer',
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework.authentication.TokenAuthentication',
        'rest_framework.authentication.SessionAuthentication',
    ),
}

# Business constants
API_GLOVO_PRODUCTION_URL = 'https://api.glovoapp.com'
API_GLOVO_TESTING_URL = 'https://stageapi.glovoapp.com'
# API_RAPPI_URL = 'https://services.rappi.com.ec/api/v2/restaurants-integrations-public-api'

# aqui se ponde la ruta donde se obtienen los token de Rappi
API_RAPPI_DEV_OAUTH = 'https://rests-integrations-dev.auth0.com/oauth/token'

API_HOST = 'http://localhost:8000'

# --------- URLs --------------
LOCAL_ADD_OREDERS_URL = 'http://localhost:8000/api/order-app/list-add'
LOCAL_GET_OREDERS_FAKE_URL = 'http://localhost:8000/api/order-app/fake/orders/'
LIST_HOST_ALLOW_CANCEL_ORDER = ['https://api.glovoapp.com', 'https://stageapi.glovoapp.com']

# -----   celery settings   ------
# CELERY_RESULT_BACKEND = 'redis://localhost:6379'
CELERY_BROKER_URL = 'redis://localhost:6379'
CELERY_BEAT_SCHEDULE = {
    'find-new-orders': {
        'task': 'order.tasks.find_new_orders',
        'schedule': timedelta(seconds=10),
        'args': ()
    },
    'update-orders-status-final': {
        'task': 'order.tasks.update_orders_status_final',
        'schedule': timedelta(seconds=10),
        'args': ()
    },
}

MINUTES_RAPPI_CANCEL_ORDER = 5
MAX_IMAGE_WEIGHT = 2.0
